#include "DualG2HighPowerMotorShield.h"

DualG2HighPowerMotorShield24v14 (md);

#define RECEIVE_PIN 2
#define CHANNEL_AMOUNT 8
#define DETECTION_SPACE 2500
#define METHOD RISING
const int deadzone = 20;
int ch[CHANNEL_AMOUNT + 1];
int move; // Forward/Back speed
int turn; // Turning Factor

void stopIfFault()
{
  if (md.getM1Fault())
  {
    md.disableDrivers();
  delay(1);
    Serial.println("M1 fault");
    while (1);
  }
  if (md.getM2Fault())
  {
    md.disableDrivers();
  delay(1);
    Serial.println("M2 fault");
    while (1);
  }
}


void setup()
{
pinMode(RECEIVE_PIN, INPUT_PULLUP);

md.init();
  md.calibrateCurrentOffsets();
Serial.begin(115200);
  delay(10);
}

void loop(){
{
ppm_write();
}

void ppm_write()
{
static unsigned long int t;
if (millis() - t < 100)
return 0;
for (byte i = 0; i < CHANNEL_AMOUNT + 1; i++)
{
Serial.print(ch[i]);
Serial.print("\t");
}
Serial.print("\n");
t = millis();
}
{
ppm_interrupt();
}
void ppm_interrupt()
{

}
static byte i;
static unsigned long int t_old;
unsigned long int t = micros(); //store time value a when pin value falling/rising
unsigned long int dt = t - t_old; //calculating time inbetween two peaks
t_old = t;

if ((dt > DETECTION_SPACE) || (i > CHANNEL_AMOUNT))
{
i = 0;
}
ch[i++] = dt;

md.enableDrivers();
  delay(1);  // The drivers require a maximum of 1ms to elapse when brought out of sleep mode.
md.setM1Speed(move);
  stopIfFault();

md.setM2Speed(move);
  stopIfFault();    



if (ch[3] > 1000)  {
      move = map(ch[3], 1000, 2000, -400, 400); //center over zero
      ch[3] = constrain(ch[3], -350, 350);
} else {
  ch[3] = 0;
}

if (abs(ch[3]) <= deadzone ) {
  ch[3] = 0;
}
return ch[3];

if (ch[1] > 1000){
   turn = map(ch[1], 1000, 2000, -400, 400);
      ch[1] = constrain(ch[1], -350, 350);
} else {
  ch[1] = 0;
}

if (abs(ch[1]) <= deadzone ) {
  ch[1] = 0;
}
return ch[1];

if(turn>0){
md.setM2Speed(move-abs (turn));
md.setM1Speed(move);
}
if(turn<0) {
md.setM1Speed(move-abs(turn));
md.setM2Speed(move);
}
Serial.println(move);
Serial.println(turn);
//delay(2000);
}
